################################################################################################
#
# Flying House
#
################################################################################################


scoreboard players set @e fly_ET 1
scoreboard players set @e[type=item] fly_ET 0
scoreboard players set @e[type=armor_stand] fly_ET 0
scoreboard players set @e[type=end_crystal] fly_ET 0
scoreboard players set @e[type=area_effect_cloud] fly_ET 0
scoreboard players set @e[type=boat] fly_ET 0
scoreboard players set @e[type=arrow] fly_ET 0
scoreboard players set @e[type=painting] fly_ET 0
scoreboard players set @e[type=player] fly_ET 0
scoreboard players set @e[type=arrow] fly_ET 0
scoreboard players set @e[type=minecart] fly_ET 0
scoreboard players set @e[type=experience_orb] fly_ET 0
scoreboard players set @e[type=zombie] fly_ET 2
scoreboard players set @e[type=zombie_villager] fly_ET 2
scoreboard players set @e[type=zombie_horse] fly_ET 2
scoreboard players set @e[type=zombie_pigman] fly_ET 2
scoreboard players set @e[type=wither_skeleton] fly_ET 2
scoreboard players set @e[type=husk] fly_ET 2
scoreboard players set @e[type=skeleton] fly_ET 2
scoreboard players set @e[type=stray] fly_ET 2

################################################################# General ################################################################


execute as @a[tag=!init_msg2] at @s run function flying_house:init

effect give @e[tag=invis] invisibility 99 9 true
effect give @a[scores={fly_was_rider=98..}] invisibility 1 9 true


##################################################################################### Flying House ################################################################################

execute as @e[tag=fly_house_house] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=fly_house,limit=1,sort=nearest] Rotation[0] 1

execute as @e[tag=fly_house] at @s run tp @e[tag=fly_house_bot] ~ ~ ~
execute as @e[tag=fly_house] at @s positioned ~ ~2 ~ run tp @e[tag=fly_house_top] ~ ~ ~

execute as @e[tag=fly_house,scores={fly_anim_in=0,fly_anim_out=0}] at @s positioned ~ ~8 ~ run tp @e[tag=fly_house_rot] ~ ~ ~
execute as @e[tag=fly_house,scores={fly_anim_in=0,fly_anim_out=0}] at @s positioned ~ ~2 ~ run tp @e[tag=fly_house_chimney] ~ ~ ~


execute as @e[tag=fly_house_rot] at @s run execute store result entity @s Rotation[0] float 1 run data get entity @e[tag=fly_house_chimney,limit=1,sort=nearest] Rotation[0] 1





##################################################################################### Spawn ################################################################################

give @a[tag=give2] minecraft:endermite_spawn_egg{display:{Name:"{\"text\":\"§6§lFlying House\"}",Lore:["Rightclick to spawn."]},EntityTag:{id:"minecraft:armor_stand",Invisible:1,NoGravity:1,Marker:1,Tags:["sp_fly"]},HideFlags:63}
tag @a[tag=give2] remove give2

execute as @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b}] at @s if block ~ ~-0.5 ~ chest{Items:[{Slot:3b,id:"minecraft:spruce_planks",Count:10b},{Slot:4b,id:"minecraft:spruce_planks",Count:10b},{Slot:5b,id:"minecraft:spruce_planks",Count:10b},{Slot:12b,id:"minecraft:oak_planks",Count:5b},{Slot:13b,id:"minecraft:bricks",Count:10b},{Slot:14b,id:"minecraft:oak_planks",Count:5b},{Slot:21b,id:"minecraft:oak_log",Count:5b},{Slot:22b,id:"minecraft:oak_log",Count:5b},{Slot:23b,id:"minecraft:oak_log",Count:5b}]} run summon area_effect_cloud ~ ~ ~ {Tags:[f_house_spawn]}

execute as @e[tag=f_house_spawn] at @s run setblock ~ ~-0.5 ~ air
execute as @e[tag=f_house_spawn] at @s run kill @e[type=item,nbt={Item:{id:"minecraft:nether_star",Count:1b},OnGround:1b},distance=..2]
execute as @e[tag=f_house_spawn] at @s run summon area_effect_cloud ~1 ~ ~ {Tags:[sp_fly]}


execute as @e[tag=sp_fly] at @s run function flying_house:set_house
execute as @e[tag=sp_fly] at @s run tp @a[distance=..6] ~-1 ~2.1 ~1
execute as @e[tag=sp_fly] at @s run function flying_house:spawn_house







##################################################################################### Animation Controller ##########################################################################

scoreboard players add @e[tag=fly_house] fly_anim_in 0
scoreboard players add @e[tag=fly_house] fly_house_state 0


tag @a remove fly_rider
tag @a[nbt={RootVehicle:{Entity:{id:"minecraft:armor_stand",Tags:["fly_ride"]}}}] add fly_rider
execute as @a[tag=fly_rider] at @s run scoreboard players set @e[tag=fly_house,scores={fly_anim_in=0,fly_house_state=0,fly_anim_out=0}] fly_anim_in 1



##################################################################################### 3rd Person Controller ##########################################################################

execute as @e[tag=fly_house,scores={fly_anim_in=0,fly_house_state=0,fly_anim_out=0}] run execute as @e[tag=fly_ride] at @s run particle enchant ~ ~0.5 ~ 0 0 0 0.3 1 force
execute as @e[tag=fly_house,scores={fly_anim_in=0,fly_house_state=0,fly_anim_out=0}] run execute as @e[tag=fly_ride] at @s run particle portal ~ ~0.5 ~ 0 0 0 0.3 1 force

scoreboard players add @e[tag=fly_house] fly_ride_tp_mode 0

execute as @e[tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run tp @e[tag=fly_pivot,limit=1,sort=nearest] ~ ~2 ~


#execute as @e[tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run tp @e[tag=fly_ride,limit=1,sort=nearest] ~-0.5 ~1 ~
execute as @e[tag=fly_house,scores={fly_ride_tp_mode=1,fly_free=0}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] run execute store result entity @s Rotation[0] float 1 run data get entity @p[tag=fly_rider] Rotation[0] 1
execute as @e[tag=fly_house,scores={fly_ride_tp_mode=1,fly_free=0}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] run execute store result entity @s Rotation[1] float 1 run data get entity @p[tag=fly_rider] Rotation[1] 1

#execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-9 run say hi



execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-9 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~


execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-11 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-10 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-12 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-11 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-13 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-12 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-14 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-13 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-15 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-14 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-16 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-15 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-17 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-16 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-18 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-17 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-19 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-18 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-20 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-19 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~

execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-21 unless block ~ ~ ~ #flying_house:passable run tag @e[tag=fly_house] add fly_tpd
execute as @e[tag=!fly_tpd,tag=fly_house,scores={fly_ride_tp_mode=1}] at @s run execute as @e[tag=fly_pivot,limit=1,sort=nearest] at @s positioned ^ ^ ^-20 if block ~ ~ ~ #flying_house:passable run tp @e[tag=fly_ride] ~ ~ ~


tag @e[tag=fly_tpd] remove fly_tpd




##################################################################################### Animation In ##########################################################################


scoreboard players add @e[tag=fly_house] fly_anim_in 0
scoreboard players add @e[tag=fly_house,scores={fly_anim_in=1..}] fly_anim_in 1

scoreboard players set @e[tag=fly_house,scores={fly_anim_in=140}] fly_control 1
execute as @e[tag=fly_house,scores={fly_anim_in=141}] at @s run data merge entity @s {NoGravity:0}
scoreboard players set @e[tag=fly_house,scores={fly_anim_in=1..}] fly_house_state 1
scoreboard players set @e[tag=fly_house,scores={fly_anim_in=1..5}] fly_ride_tp_mode 1


execute as @e[tag=fly_house,scores={fly_anim_in=2}] at @s run setblock ~ ~1 ~ glass
execute as @e[tag=fly_house,scores={fly_anim_in=2}] at @s run function flying_house:activate_house
execute as @e[tag=fly_house,scores={fly_anim_in=5}] at @s run execute as @e[tag=fly_part1] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:20},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part2] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:21},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part3] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:22},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part4] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:23},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part5] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:24},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part6] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:25},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part7] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:26},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_part8] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:27},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=4}] at @s run execute as @e[tag=fly_house_chimney] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:28},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=5}] at @s run function flying_house:remove_house


scoreboard players set @e[tag=fly_house,scores={fly_anim_in=20}] fly_anim_in 39
scoreboard players set @e[tag=fly_house,scores={fly_anim_in=141}] fly_anim_in 0

execute as @e[tag=fly_house,scores={fly_anim_in=90}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 1
execute as @e[tag=fly_house,scores={fly_anim_in=100}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 2
execute as @e[tag=fly_house,scores={fly_anim_in=110}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 3
execute as @e[tag=fly_house,scores={fly_anim_in=120}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 4
execute as @e[tag=fly_house,scores={fly_anim_in=130}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 5
execute as @e[tag=fly_house,scores={fly_anim_in=140}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 6


execute as @e[tag=fly_house,scores={fly_anim_in=41..80}] at @s run execute as @e[tag=fly_rot1] at @s run tp @s ~ ~ ~0.125
execute as @e[tag=fly_house,scores={fly_anim_in=41..80}] at @s run execute as @e[tag=fly_rot2] at @s run tp @s ~ ~ ~-0.125
execute as @e[tag=fly_house,scores={fly_anim_in=41..80}] at @s run execute as @e[tag=fly_rot3] at @s run tp @s ~-0.125 ~ ~
execute as @e[tag=fly_house,scores={fly_anim_in=41..80}] at @s run execute as @e[tag=fly_rot4] at @s run tp @s ~0.125 ~ ~


execute as @e[tag=fly_house,scores={fly_anim_in=43}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:33},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=52}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:32},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=60}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:31},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=68}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:30},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_in=76}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:29},Count:1b}]}



##################################################################################### Animation Out ##########################################################################

scoreboard players add @a fly_was_rider 0
scoreboard players remove @a[scores={fly_was_rider=1..}] fly_was_rider 1
scoreboard players set @a[tag=fly_rider] fly_was_rider 100


scoreboard players add @e[tag=fly_house,scores={fly_house_state=1,fly_anim_in=0,fly_anim_out=0}] fly_rider_exit 1
execute as @a[tag=fly_rider] at @s run scoreboard players set @e[tag=fly_house] fly_rider_exit 0

scoreboard players set @e[tag=fly_house,scores={fly_rider_exit=3..}] fly_anim_out 1



scoreboard players add @e[tag=fly_house] fly_anim_out 0
scoreboard players add @e[tag=fly_house,scores={fly_anim_out=1..}] fly_anim_out 1

scoreboard players set @e[tag=fly_house,scores={fly_anim_out=1..}] fly_control 0
scoreboard players set @e[tag=fly_house,scores={fly_anim_out=1..}] fly_rider_exit 0
scoreboard players set @e[tag=fly_house,scores={fly_anim_out=200..}] fly_anim_out 0
scoreboard players set @e[tag=fly_house,scores={fly_anim_out=136}] fly_house_state 0
scoreboard players set @e[tag=fly_house,scores={fly_anim_out=136}] fly_ride_tp_mode 0

#---------------- Align -------------#

execute as @e[tag=fly_house,scores={fly_anim_out=2}] at @s align xyz positioned ~0.5 ~ ~0.5 run tp @s ~ ~ ~

execute as @e[tag=fly_house,scores={fly_anim_out=1..5}] at @s positioned ~ ~8 ~ run tp @e[tag=fly_house_rot] ~ ~ ~
execute as @e[tag=fly_house,scores={fly_anim_out=1..5}] at @s positioned ~ ~2 ~ run tp @e[tag=fly_house_chimney] ~ ~ ~

execute as @e[tag=fly_house,scores={fly_anim_out=3..79},y_rotation=6..179] at @s run tp @s ~ ~ ~ ~-5 ~
execute as @e[tag=fly_house,scores={fly_anim_out=3..79},y_rotation=-179..-6] at @s run tp @s ~ ~ ~ ~5 ~
execute as @e[tag=fly_house,scores={fly_anim_out=3..79},y_rotation=-6..6] at @s run tp @s ~ ~ ~ 0 0


execute as @e[tag=fly_house,scores={fly_anim_out=80}] at @s run tp @s ~ ~ ~ 0 0

scoreboard players set @e[tag=fly_house,scores={fly_anim_out=2..}] fly_vert 0
scoreboard players set @e[tag=fly_house,scores={fly_anim_out=2..}] fly_dir 0
scoreboard players set @e[tag=fly_house,scores={fly_anim_out=2..}] fly_forward 0
execute as @e[tag=fly_house,scores={fly_anim_out=2..}] at @s run clear @a[scores={fly_was_rider=90..}] carrot_on_a_stick



execute as @e[tag=fly_house,scores={fly_anim_out=1..}] at @s run data merge entity @s {NoGravity:1}

execute as @e[tag=fly_house,scores={fly_anim_out=2}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 5
execute as @e[tag=fly_house,scores={fly_anim_out=8}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 4

execute as @e[tag=fly_house,scores={fly_anim_out=8..41}] at @s run execute at @e[tag=fly_house_chimney,y_rotation=0..11] run scoreboard players set @s fly_anim_out 42


execute as @e[tag=fly_house,scores={fly_anim_out=42}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 3
execute as @e[tag=fly_house,scores={fly_anim_out=42..69}] at @s run execute at @e[tag=fly_house_chimney,y_rotation=-8..0] run scoreboard players set @s fly_anim_out 70
execute as @e[tag=fly_house,scores={fly_anim_out=42..69}] at @s run execute at @e[tag=fly_house_chimney,y_rotation=-98..-90] run scoreboard players set @s fly_anim_out 70
execute as @e[tag=fly_house,scores={fly_anim_out=42..69}] at @s run execute at @e[tag=fly_house_chimney,y_rotation=172..180] run scoreboard players set @s fly_anim_out 70
execute as @e[tag=fly_house,scores={fly_anim_out=42..69}] at @s run execute at @e[tag=fly_house_chimney,y_rotation=82..90] run scoreboard players set @s fly_anim_out 70

execute as @e[tag=fly_house,scores={fly_anim_out=70}] at @s run execute as @e[tag=fly_house_chimney,y_rotation=-90..-1] at @s run tp @s ~ ~ ~ 0 ~
execute as @e[tag=fly_house,scores={fly_anim_out=70}] at @s run execute as @e[tag=fly_house_chimney,y_rotation=-180..-91] at @s run tp @s ~ ~ ~ -90 ~
execute as @e[tag=fly_house,scores={fly_anim_out=70}] at @s run execute as @e[tag=fly_house_chimney,y_rotation=90..179] at @s run tp @s ~ ~ ~ 180 ~
execute as @e[tag=fly_house,scores={fly_anim_out=70}] at @s run execute as @e[tag=fly_house_chimney,y_rotation=0..89] at @s run tp @s ~ ~ ~ 90 ~


execute as @e[tag=fly_house,scores={fly_anim_out=75}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 2
execute as @e[tag=fly_house,scores={fly_anim_out=85}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 1
execute as @e[tag=fly_house,scores={fly_anim_out=93}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 0



execute as @e[tag=fly_house,scores={fly_anim_out=95..134}] at @s run execute as @e[tag=fly_rot1] at @s run tp @s ~ ~ ~0.125
execute as @e[tag=fly_house,scores={fly_anim_out=95..134}] at @s run execute as @e[tag=fly_rot2] at @s run tp @s ~ ~ ~-0.125
execute as @e[tag=fly_house,scores={fly_anim_out=95..134}] at @s run execute as @e[tag=fly_rot3] at @s run tp @s ~-0.125 ~ ~
execute as @e[tag=fly_house,scores={fly_anim_out=95..134}] at @s run execute as @e[tag=fly_rot4] at @s run tp @s ~0.125 ~ ~


execute as @e[tag=fly_house,scores={fly_anim_out=99}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:29},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_out=108}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:30},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_out=114}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:31},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_out=120}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:32},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_out=128}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:33},Count:1b}]}
execute as @e[tag=fly_house,scores={fly_anim_out=136}] at @s run execute as @e[tag=fly_house_rot] run data merge entity @s {ArmorItems:[{},{},{},{}]}


execute as @e[tag=fly_house,scores={fly_anim_out=138..139}] at @s run tp @e[tag=fly_ride] ~1 ~2 ~
execute as @e[tag=fly_house,scores={fly_anim_out=139..141}] at @s run execute as @a[scores={fly_was_rider=90..}] at @s run tp @s ~ ~ ~
effect clear @a[scores={fly_was_rider=95}] invisibility
execute as @e[tag=fly_house,scores={fly_anim_out=140}] at @s run function flying_house:set_house
execute as @e[tag=fly_house,scores={fly_anim_out=140}] at @s run kill @e[tag=fly_house_house]
execute as @e[tag=fly_house,scores={fly_anim_out=140}] at @s run kill @e[tag=fly_house_rot]
execute as @e[tag=fly_house,scores={fly_anim_out=140}] at @s run kill @e[tag=fly_house_chimney]
execute as @e[tag=fly_house,scores={fly_anim_out=140}] at @s run execute as @e[tag=suck_stored] at @s run data merge entity @s {NoAI:0}
execute as @e[tag=fly_house,scores={fly_anim_out=140}] at @s run tag @e[tag=suck_stored] remove suck_stored


##################################################################################### Movement ##########################################################################

execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=1}] at @s run tp @s ~ ~ ~ ~2 ~
execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=2}] at @s run tp @s ~ ~ ~ ~4 ~
execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=3}] at @s run tp @s ~ ~ ~ ~7 ~
execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=4}] at @s run tp @s ~ ~ ~ ~10 ~
execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=5}] at @s run tp @s ~ ~ ~ ~13 ~
execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=6}] at @s run tp @s ~ ~ ~ ~20 ~
execute as @e[tag=fly_house_chimney,scores={fly_rot_speed=7}] at @s run tp @s ~ ~ ~ ~25 ~



##################################################################################### Controls ##########################################################################

execute as @e[tag=fly_house,scores={fly_control=1,fly_dir=-1}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.3 carrot_on_a_stick{Damage:7,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_dir=0..}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.3 carrot_on_a_stick{Damage:6,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1



execute as @e[tag=fly_house,scores={fly_control=1,fly_forward=1}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.4 carrot_on_a_stick{Damage:5,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_forward=0}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.4 carrot_on_a_stick{Damage:4,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1

execute as @e[tag=fly_house,scores={fly_control=1,fly_dir=1}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.5 carrot_on_a_stick{Damage:9,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_dir=..0}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.5 carrot_on_a_stick{Damage:8,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1




execute as @e[tag=fly_house,scores={fly_control=1,fly_vert=0..}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.6 carrot_on_a_stick{Damage:2,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_vert=-1}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.6 carrot_on_a_stick{Damage:3,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1

execute as @e[tag=fly_house,scores={fly_control=1,fly_vert=..0}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.7 carrot_on_a_stick{Damage:0,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_vert=1}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.7 carrot_on_a_stick{Damage:1,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1

execute as @e[tag=fly_house,scores={fly_control=1}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.8 carrot_on_a_stick{Damage:10,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1

execute as @e[tag=fly_house,scores={fly_control=1,fly_suck_timer=1..}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.1 carrot_on_a_stick{Damage:13,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_suck_timer=0}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.1 carrot_on_a_stick{Damage:14,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1

execute as @e[tag=fly_house,scores={fly_control=1,fly_free=1..}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.2 carrot_on_a_stick{Damage:15,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_free=..0}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.2 carrot_on_a_stick{Damage:16,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1

execute as @e[tag=fly_house,scores={fly_control=1,fly_tnt_cd=0}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.0 carrot_on_a_stick{Damage:12,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1
execute as @e[tag=fly_house,scores={fly_control=1,fly_tnt_cd=1..}] at @s run replaceitem entity @a[tag=fly_rider,limit=1,sort=nearest] hotbar.0 carrot_on_a_stick{Damage:11,Unbreakable:1,HideFlags:63,display:{Name:"{\"text\":\"\"}"}} 1


scoreboard players add @e[tag=fly_house] fly_dir 0
scoreboard players add @e[tag=fly_house] fly_forward 0
scoreboard players add @e[tag=fly_house] fly_vert 0

execute as @a[nbt={SelectedItemSlot:3},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_dir=0}] fly_dir -2
execute as @a[nbt={SelectedItemSlot:3},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_dir=1}] fly_dir -2
execute as @a[nbt={SelectedItemSlot:3},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_dir=-1}] fly_dir 0
scoreboard players set @e[tag=fly_house,scores={fly_dir=-2}] fly_dir -1

execute as @a[nbt={SelectedItemSlot:5},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_dir=0}] fly_dir 2
execute as @a[nbt={SelectedItemSlot:5},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_dir=-1}] fly_dir 2
execute as @a[nbt={SelectedItemSlot:5},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_dir=1}] fly_dir 0
scoreboard players set @e[tag=fly_house,scores={fly_dir=2}] fly_dir 1

execute as @a[nbt={SelectedItemSlot:4},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_forward=0}] fly_forward 2
execute as @a[nbt={SelectedItemSlot:4},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_forward=1}] fly_forward -1
scoreboard players set @e[tag=fly_house,scores={fly_forward=2}] fly_forward 1
scoreboard players set @e[tag=fly_house,scores={fly_forward=-1}] fly_forward 0


execute as @a[nbt={SelectedItemSlot:6},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_vert=0}] fly_vert -2
execute as @a[nbt={SelectedItemSlot:6},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_vert=1}] fly_vert -2
execute as @a[nbt={SelectedItemSlot:6},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_vert=-1}] fly_vert 0
scoreboard players set @e[tag=fly_house,scores={fly_vert=-2}] fly_vert -1

execute as @a[nbt={SelectedItemSlot:7},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_vert=0}] fly_vert 2
execute as @a[nbt={SelectedItemSlot:7},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_vert=-1}] fly_vert 2
execute as @a[nbt={SelectedItemSlot:7},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_vert=1}] fly_vert 0
scoreboard players set @e[tag=fly_house,scores={fly_vert=2}] fly_vert 1


execute as @e[tag=fly_house,scores={fly_dir=-1,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run tp @s ~ ~ ~ ~-2 ~
execute as @e[tag=fly_house,scores={fly_dir=1,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run tp @s ~ ~ ~ ~2 ~


execute as @e[tag=fly_house,scores={fly_forward=1,fly_house_state=1,fly_anim_out=0,fly_anim_in=0,fly_suck_timer=0}] at @s run function flying_house:fly_forward
execute as @e[tag=fly_house,scores={fly_forward=0,fly_house_state=1,fly_anim_out=0,fly_anim_in=0,fly_suck_timer=0}] at @s run function flying_house:fly
execute as @e[tag=fly_house,scores={fly_suck_timer=1..}] at @s run function flying_house:hover


execute as @e[tag=fly_house,scores={fly_vert=1,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 5
execute as @e[tag=fly_house,scores={fly_vert=0,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 6
execute as @e[tag=fly_house,scores={fly_vert=-1,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run scoreboard players set @e[tag=fly_house_chimney] fly_rot_speed 7

execute as @e[tag=fly_house,scores={fly_vert=1,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run particle cloud ~ ~10 ~ 3 0 3 0.04 1 force
execute as @e[tag=fly_house,scores={fly_vert=0,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run particle cloud ~ ~10 ~ 3 0 3 0.1 1 force
execute as @e[tag=fly_house,scores={fly_vert=-1,fly_anim_out=0,fly_anim_in=0,fly_house_state=1}] at @s run particle cloud ~ ~10 ~ 3 0 3 0.2 1 force


execute as @a[nbt={SelectedItemSlot:8},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_anim_out=0}] fly_anim_out 1
execute as @a[nbt={SelectedItemSlot:1},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_suck_timer=0,fly_anim_out=0,fly_anim_in=0}] fly_suck_timer 1








##################################################################################### House Kill ##########################################################################


execute as @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b}] at @s run execute as @e[tag=fly_house,scores={fly_house_state=0,fly_anim_in=0,fly_anim_out=0},distance=..3] at @s run summon area_effect_cloud ~ ~ ~ {Tags:[fly_house_kill]}

execute as @e[tag=fly_house_kill] at @s run kill @e[type=item,nbt={Item:{id:"minecraft:tnt",Count:64b},OnGround:1b}]
execute as @e[tag=fly_house_kill] at @s run function flying_house:remove_house
execute as @e[tag=fly_house_kill] at @s run execute as @e[tag=fly_pig] at @s run data merge entity @s {DeathTime:19,Health:0}
execute as @e[tag=fly_house_kill] at @s run tag @p add give2
execute as @e[tag=fly_house_kill] at @s run kill @e[tag=fly_house_as]
execute as @e[tag=fly_house_kill] at @s run kill @e[type=item]



##################################################################################### Suck ##########################################################################

scoreboard players add @e[tag=fly_house] fly_suck_timer 0
scoreboard players add @e[tag=fly_house,scores={fly_suck_timer=1..}] fly_suck_timer 1
scoreboard players set @e[tag=fly_house,scores={fly_suck_timer=60..}] fly_suck_timer 0

execute as @e[tag=fly_house,scores={fly_suck_timer=2}] at @s run summon armor_stand ~ ~ ~ {Motion:[0.0,-5.0,0.0],Tags:[fly_suck_point],Invisible:1}
execute as @e[tag=fly_house,scores={fly_suck_timer=15}] at @s run execute as @e[tag=fly_suck_point] at @s run tag @e[scores={fly_ET=1..2},distance=..5] add fly_sucked
execute as @e[tag=fly_house,scores={fly_suck_timer=15}] at @s run execute as @e[tag=fly_suck_point] at @s run tp @e[tag=fly_sucked] ~ ~ ~
execute as @e[tag=fly_house,scores={fly_suck_timer=2..50}] at @s run execute as @e[tag=fly_suck_point,distance=15..] run particle cloud ~ ~-20 ~ 0.1 10 0.1 0.02 1 force
execute as @e[tag=fly_house,scores={fly_suck_timer=2..50}] at @s run particle cloud ~ ~-5 ~ 0.1 5 0.1 0.02 1 force
execute as @e[tag=fly_house,scores={fly_suck_timer=2..50}] at @s run particle portal ~ ~-5 ~ 0.1 5 0.1 0.05 5 force
execute as @e[tag=fly_house,scores={fly_suck_timer=15..50}] at @s run execute as @e[tag=fly_suck_point] at @s run particle cloud ~ ~2 ~ 0 1 0 1 0 force
execute as @e[tag=fly_house,scores={fly_suck_timer=59}] at @s run kill @e[tag=fly_suck_point]

execute as @e[tag=fly_sucked] at @s run data merge entity @s {NoAI:1}
execute as @e[tag=fly_house,scores={fly_suck_timer=15..50}] at @s run execute as @e[tag=fly_sucked] at @s run tp @s ~ ~0.2 ~
execute as @e[tag=fly_house,scores={fly_suck_timer=15..50}] at @s positioned ~ ~1 ~ run tag @e[tag=fly_sucked,distance=..1] add done_sucked

execute as @e[tag=fly_sucked,tag=!done_sucked] run scoreboard players set @e[tag=fly_house,scores={fly_suck_timer=15..50}] fly_suck_timer 48

tag @e[tag=done_sucked] remove fly_sucked
tag @e[tag=done_sucked] add suck_stored
tag @e[tag=done_sucked] remove done_sucked

execute as @e[tag=fly_house,scores={fly_house_state=1}] at @s run tp @e[tag=suck_stored] ~-1 ~2 ~1



##################################################################################### Compass ##########################################################################

execute as @a[nbt={SelectedItemSlot:2},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_free=0}] fly_free 5
execute as @a[nbt={SelectedItemSlot:2},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_free=1}] fly_free -5

scoreboard players add @e[tag=fly_house] fly_free 0
scoreboard players remove @e[tag=fly_house,scores={fly_free=2..}] fly_free 1
scoreboard players add @e[tag=fly_house,scores={fly_free=..-1}] fly_free 1




##################################################################################### Tnt ##########################################################################


scoreboard players add @e[tag=fly_house] fly_tnt_cd 0
scoreboard players add @e[tag=fly_house,scores={fly_tnt_cd=1..}] fly_tnt_cd 1
scoreboard players set @e[tag=fly_house,scores={fly_tnt_cd=20..}] fly_tnt_cd 0

execute as @a[nbt={SelectedItemSlot:0},scores={rc2=1..,fly_was_rider=1..}] run scoreboard players set @e[tag=fly_house,scores={fly_control=1,fly_tnt_cd=0,fly_anim_out=0,fly_anim_in=0}] fly_tnt_cd 1
execute as @e[tag=fly_house,scores={fly_tnt_cd=2}] at @s run summon armor_stand ~ ~ ~ {ArmorItems:[{},{},{},{id:"minecraft:diamond_pickaxe",tag:{Unbreakable:1,Damage:12},Count:1b}],Invisible:1,Tags:[fly_tnt]}

execute as @e[tag=fly_tnt,nbt={OnGround:1b}] at @s run summon minecraft:tnt ~ ~ ~ {Fuse:0}
kill @e[tag=fly_tnt,nbt={OnGround:1b}]

scoreboard players set @a rc2 0
