################################################################################################
#
# Set House Blocks
#
################################################################################################

#---------- Leaves -------------#
fill ~5 ~ ~4 ~-4 ~ ~-4 oak_leaves[persistent=true]
fill ~5 ~ ~-1 ~3 ~ ~-4 air

#---------- Floor -------------#
fill ~4 ~ ~3 ~-3 ~ ~1 stone_bricks
fill ~1 ~ ~-3 ~-3 ~ ~ stone_bricks


#---------- Ceiling -------------#

fill ~1 ~5 ~2 ~-3 ~5 ~-2 spruce_planks
setblock ~-1 ~5 ~ redstone_lamp
setblock ~-1 ~6 ~ redstone_block


#---------- Walls -------------#
fill ~1 ~2 ~4 ~-3 ~3 ~4 bricks
fill ~1 ~2 ~-4 ~-3 ~3 ~-4 bricks
fill ~-4 ~2 ~-3 ~-4 ~4 ~3 bricks
fill ~2 ~2 ~-3 ~2 ~4 ~3 bricks

#---------- Upper Walls -------------#

fill ~2 ~5 ~-2 ~2 ~5 ~2 oak_planks
fill ~2 ~6 ~-1 ~2 ~6 ~1 oak_planks

fill ~-4 ~5 ~-2 ~-4 ~5 ~2 oak_planks
fill ~-4 ~6 ~-1 ~-4 ~6 ~1 oak_planks

#---------- Bottom Side Stairs -------------#
fill ~1 ~1 ~-4 ~-3 ~1 ~-4 oak_stairs[facing=south,half=top]
fill ~4 ~1 ~4 ~-3 ~1 ~4 oak_stairs[facing=north,half=top]
fill ~-4 ~1 ~-3 ~-4 ~1 ~3 oak_stairs[facing=east,half=top]
fill ~2 ~1 ~-1 ~2 ~1 ~-3 oak_stairs[facing=west,half=top]
fill ~5 ~1 ~1 ~5 ~1 ~3 oak_stairs[facing=west,half=top]

#---------- Floor -------------#
fill ~-3 ~1 ~3 ~1 ~1 ~-3 oak_planks
fill ~2 ~1 ~3 ~4 ~1 ~1 oak_planks

#---------- Staircase -------------#
fill ~3 ~1 ~1 ~4 ~1 ~1 oak_stairs[facing=south,half=bottom]
fill ~3 ~ ~ ~4 ~ ~ oak_stairs[facing=south,half=bottom]


#---------- Door -------------#
setblock ~2 ~2 ~2 oak_door[half=lower,hinge=left,facing=west,open=false]
setblock ~2 ~3 ~2 oak_door[half=upper,hinge=left,facing=west,open=false]


#---------- Windows -------------#
setblock ~2 ~2 ~-2 brick_stairs[facing=west,half=bottom]
setblock ~2 ~3 ~-2 glass_pane[south=true,north=true]
setblock ~2 ~4 ~-2 brick_stairs[facing=west,half=top]

setblock ~-4 ~2 ~-2 brick_stairs[facing=east,half=bottom]
setblock ~-4 ~3 ~-2 glass_pane[south=true,north=true]
setblock ~-4 ~4 ~-2 brick_stairs[facing=east,half=top]

setblock ~-4 ~2 ~2 brick_stairs[facing=east,half=bottom]
setblock ~-4 ~3 ~2 glass_pane[south=true,north=true]
setblock ~-4 ~4 ~2 brick_stairs[facing=east,half=top]


#---------- Roof -------------#

fill ~3 ~3 ~5 ~-5 ~3 ~5 spruce_stairs[facing=north,half=bottom]
fill ~3 ~4 ~4 ~-5 ~4 ~4 spruce_stairs[facing=north,half=bottom]
fill ~3 ~5 ~3 ~-5 ~5 ~3 spruce_stairs[facing=north,half=bottom]
fill ~3 ~6 ~2 ~-5 ~6 ~2 spruce_stairs[facing=north,half=bottom]
fill ~3 ~7 ~1 ~-5 ~7 ~1 spruce_stairs[facing=north,half=bottom]

fill ~3 ~3 ~-5 ~-5 ~3 ~-5 spruce_stairs[facing=south,half=bottom]
fill ~3 ~4 ~-4 ~-5 ~4 ~-4 spruce_stairs[facing=south,half=bottom]
fill ~3 ~5 ~-3 ~-5 ~5 ~-3 spruce_stairs[facing=south,half=bottom]
fill ~3 ~6 ~-2 ~-5 ~6 ~-2 spruce_stairs[facing=south,half=bottom]
fill ~3 ~7 ~-1 ~-5 ~7 ~-1 spruce_stairs[facing=south,half=bottom]

fill ~2 ~8 ~ ~-4 ~8 ~ spruce_slab[type=bottom]
fill ~-5 ~8 ~ ~-5 ~8 ~ spruce_stairs[facing=west,half=bottom]
fill ~3 ~8 ~ ~3 ~8 ~ spruce_stairs[facing=east,half=bottom]

fill ~-5 ~7 ~ ~-5 ~7 ~ spruce_stairs[facing=east,half=top]
fill ~3 ~7 ~ ~3 ~7 ~ spruce_stairs[facing=west,half=top]


setblock ~-5 ~6 ~1 spruce_stairs[facing=south,half=top]
setblock ~-5 ~5 ~2 spruce_stairs[facing=south,half=top]
setblock ~-5 ~4 ~3 spruce_stairs[facing=south,half=top]
setblock ~-5 ~3 ~4 spruce_stairs[facing=south,half=top]

setblock ~-5 ~6 ~-1 spruce_stairs[facing=north,half=top]
setblock ~-5 ~5 ~-2 spruce_stairs[facing=north,half=top]
setblock ~-5 ~4 ~-3 spruce_stairs[facing=north,half=top]
setblock ~-5 ~3 ~-4 spruce_stairs[facing=north,half=top]

setblock ~3 ~6 ~1 spruce_stairs[facing=south,half=top]
setblock ~3 ~5 ~2 spruce_stairs[facing=south,half=top]
setblock ~3 ~4 ~3 spruce_stairs[facing=south,half=top]
setblock ~3 ~3 ~4 spruce_stairs[facing=south,half=top]

setblock ~3 ~6 ~-1 spruce_stairs[facing=north,half=top]
setblock ~3 ~5 ~-2 spruce_stairs[facing=north,half=top]
setblock ~3 ~4 ~-3 spruce_stairs[facing=north,half=top]
setblock ~3 ~3 ~-4 spruce_stairs[facing=north,half=top]



#---------- Roof Windows -------------#

setblock ~ ~4 ~4 spruce_stairs[facing=west,shape=inner_left]
setblock ~-1 ~4 ~4 glass_pane[west=true,east=true]
setblock ~-1 ~5 ~4 spruce_slab[type=bottom]
setblock ~-2 ~4 ~4 spruce_stairs[shape=inner_left,facing=east]

setblock ~ ~4 ~-4 spruce_stairs[facing=west,shape=inner_left]
setblock ~-1 ~4 ~-4 glass_pane[west=true,east=true]
setblock ~-1 ~5 ~-4 spruce_slab[type=bottom]
setblock ~-2 ~4 ~-4 spruce_stairs[facing=east,shape=inner_right]


#---------- Pillars -------------#
fill ~5 ~ ~4 ~5 ~2 ~4 oak_log
fill ~5 ~ ~ ~5 ~2 ~ oak_log
fill ~2 ~ ~ ~2 ~7 ~ oak_log
fill ~-4 ~ ~ ~-4 ~7 ~ oak_log
fill ~2 ~ ~-4 ~2 ~3 ~-4 oak_log
fill ~-4 ~ ~-4 ~-4 ~3 ~-4 oak_log
fill ~-4 ~ ~4 ~-4 ~3 ~4 oak_log
fill ~2 ~ ~4 ~2 ~3 ~4 oak_log


#---------- Fences -------------#

fill ~3 ~2 ~4 ~4 ~2 ~4 oak_fence[west=true,east=true]
fill ~5 ~2 ~3 ~5 ~2 ~1 oak_fence[north=true,south=true]
fill ~5 ~3 ~ ~5 ~4 ~ oak_fence

#---------- Patio Roof -------------#

fill ~4 ~3 ~4 ~5 ~3 ~4 spruce_stairs[facing=north,half=bottom]
fill ~4 ~4 ~3 ~5 ~4 ~3 spruce_slab[type=bottom]
fill ~3 ~4 ~3 ~3 ~4 ~3 spruce_stairs[facing=south,half=top]
fill ~3 ~4 ~2 ~5 ~4 ~2 spruce_slab[type=top]
fill ~3 ~5 ~1 ~5 ~5 ~0 spruce_slab[type=bottom]

#---------- Interior -------------#

setblock ~-1 ~2 ~-1 enchanting_table
setblock ~1 ~2 ~-1 bookshelf

setblock ~-3 ~2 ~-2 bookshelf
fill ~-3 ~2 ~-3 ~-3 ~4 ~-3 bookshelf
setblock ~-2 ~2 ~-3 bookshelf
fill ~-1 ~2 ~-3 ~1 ~3 ~-3 bookshelf
setblock ~1 ~4 ~-3 bookshelf

setblock ~-3 ~2 ~ ender_chest[facing=east]
setblock ~-3 ~2 ~3 crafting_table
setblock ~-1 ~2 ~3 furnace[facing=north]


#---------- Chimney -------------#

setblock ~0 ~8 ~ cobblestone
setblock ~0 ~9 ~ cobblestone_wall
setblock ~0 ~10 ~ cobblestone_slab[type=bottom]






#/execute as @e[tag=flying_house_center] at @s run function flying_house:set_house





#fill ~ ~ ~ ~ ~ ~ 
